//
// ~ΐؒf쐬
//
// written by T.Noda
//
// 2001/06/26 Ver 0.0.1 Wʒu_ŕ\
// 2001/06/27 Ver 0.0.2 WJ}~ʂŕ
// 2001/06/29 Ver 0.0.3 px͉̓\͈͂ύX
// 2001/07/19 Ver 0.0.4 fʓWJǉ
//
// D:a H: A:ؒfpx
//
//
//************************************
//
//  f[^ւ
//
//************************************
procedure SwapValue(var SA : double; var EA : double);
var
  temp : double;
begin
  temp := SA;
  SA := EA;
  EA := temp;
end;
//************************************
//
//  a擾
//
//************************************
function RadiusGet(px1 : double; py1 : double; px2 : double; py2 : double; px3 : double; py3 : double) : double;
var
  L1, L2, L3 : double;
begin
  L1 := Distance(px1, py1, px2, py2);
  L2 := Distance(px2, py2, px3, py3);
  L3 := Distance(px3, py3, px1, py1);
  Result := 0.5*L2/(sin(ArcCos((L1*L1+L3*L3-L2*L2)/(2.0*L1*L3))));
end;
//************************************
//
//  SW擾
//
//************************************
procedure CenterPointGet(var x0 : double; var y0 : double; x1 : double; y1 : double; x2 : double; y2 : double; x3 : double; y3 : double);
var
  a1, a2, b1, b2, xm1, ym1, xm2, ym2, ang1, ang2 : double;
  flg1, flg2 : boolean;
begin
  xm1 := 0.5*(x1+x2);  // _擾
  ym1 := 0.5*(y1+y2);
  xm2 := 0.5*(x2+x3);
  ym2 := 0.5*(y2+y3);
  ang1 := PosToAngl(x1, y1, x2, y2)+90.0;
  if ang1 > 360.0 then
  begin
    ang1 := ang1-360.0;
  end;
  ang2 := PosToAngl(x2, y2, x3, y3)+90.0;
  if ang2 > 360.0 then
  begin
    ang2 := ang2-360.0;
  end;
  if (ang1=90.0)OR(ang1=270.0) then
  begin
    x0 := xm1;
    flg1 := true;
  end
  else
  begin
    a1 := tan(ang1);
    b1 := ym1-a1*xm1;
    flg1 := false;
  end;
  if (ang2=90.0)OR(ang2=270.0) then
  begin
    x0 := xm2;
    flg2 := true;
  end
  else
  begin
    a2 := tan(ang2);
    b2 := ym2-a2*xm2;
    flg2 := false;
  end;
  if flg1 = true then
  begin
    y0 := a2*x0+b2;
  end
  else if flg2 = true then
  begin
    y0 := a1*x0+b1;
  end
  else
  begin
    x0 := -(b2-b1)/(a2-a1);
    y0 := -(a1*b2-a2*b1)/(a2-a1);
  end;
end;
//************************************
//
//  ~ʕԕ` 2001/07/19
//
//************************************
procedure PrintArc(x1 : double; y1 : double; x2 : double; y2 : double; x3 : double; y3 : double; xm : double);
var
  x0, y0, r, SA, EA : double;
begin
  r := RadiusGet(x1, y1, x2, y2, x3, y3);
  CenterPointGet(x0, y0, x1, y1, x2, y2, x3, y3);
  SA := PosToAngl(x0, y0, x1, y1);
  EA := PosToAngl(x0, y0, x3, y3);
  if EA < SA then
    begin
      SwapValue(SA, EA);
    end;
  if Abs(EA-SA) > 180.0 then
    begin
      SwapValue(SA, EA);
    end;
  AnglCheck(SA, EA);
  Arc(x0, y0, r, SA, EA);
  x0 := 2.0*xm-x0;
  SA := 540.0-SA;
  EA := 540.0-EA;
  Arc(x0, y0, r, EA, SA);
end;
//************************************
//
//  CvO
//
//************************************
Program CYLINDER;
var
  x, y : Array of double;
  D, H, A : double;
  i : integer;

Begin
  AddImage(20, 20, 'CYLINDER_PARAM.BMP');

  AddLabel(145, 23, 95, 13, 'a(D)');
  AddLabel(145, 48, 95, 13, '(H)');
  AddLabel(145, 73, 95, 13, 'ؒfpx(A)');
  AddEdit(1, 230, 20, 50, 21, '');
  AddEdit(2, 230, 45, 50, 21, '');
  AddEdit(3, 230, 70, 50, 21, '');
  AddCheckBox(1, 25, 130, true, '⏕}'); // `FbN{bNX
  AddCheckBox(2, 120, 130, false, 'fʓWJ'); // `FbN{bNX

  If ShowDlg(300, 200,'~ΐؒf}_CAO') <> True Then
    Exit;

  D := StrToFloat(GetDlgText(1)); // ɕϊ
  H := StrToFloat(GetDlgText(2));
  A := StrToFloat(GetDlgText(3));
  if (A-89.999 > 0.0) OR (A < 0.0) then
  begin
    OkMsgBox('px̒lsłB');
    exit;
  end;
  if (H <= D*tan(A)) AND (CheckBoxChecked(2)=false) then
  begin
    if MsgBox('sĂ܂Bs܂H') = false then
    begin
      exit;
    end;
  end;
  SetArrayLength(x, 6);
  SetArrayLength(y, 6);
  Message('zuʒu͂ĉB');
  if GetPos(x[5], y[5]) = false then
  begin
    exit.
  end;
  LineType(0);  // 
  PenNo(1);     // yԍ
  if CheckBoxChecked(2) then  // fʓWJ
  begin
    x[0] := x[5];
    y[0] := y[5];
    if CheckBoxChecked(1) then  // ⏕
    begin
      LineType(3);  // 
      Line(x[0]-0.25*D, y[0], x[0]+0.25*D, y[0]);
      Line(x[0], y[0]-0.25*D, x[0], y[0]+0.25*D);
      LineType(0);  // 
    end
    else
    begin
      Point(x[0], y[0]);
    end;
    if A = 0.0 then
    begin
      Circle(x[0], y[0], 0.5*D);
      exit;
    end;
    for i:=0 to 12 do
    begin
      x[4] := x[0]+0.5*D*cos(i*7.5);
      y[4] := y[0]+0.5*(D/cos(A))*sin(i*7.5);
      if i=0 then
      begin
        x[1] := x[4];
        y[1] := y[4];
      end
      else if (i mod 2) = 1 then
      begin
        x[2] := x[4];
        y[2] := y[4];
      end
      else
      begin
        x[3] := x[4];
        y[3] := y[4];
        PrintArc(x[1], y[1], x[2], y[2], x[3], y[3], x[0]);
        PrintArc(x[1], 2.0*y[0]-y[1], x[2], 2.0*y[0]-y[2], x[3], 2.0*y[0]-y[3], x[0]);
        x[1] := x[3];
        y[1] := y[3];
      end;
    end;
  end
  else // ~WJ
  begin
    x[0] := x[5]+0.5*D*Pi;
    y[0] := y[5]+H;
    Line(x[5], y[5], x[5], y[0]-D*tan(A));
    Line(x[5], y[5], x[5]+D*Pi, y[5]);
    Line(x[5]+D*Pi, y[5], x[5]+D*Pi, y[0]-D*tan(A));
    if A = 0.0 then
    begin
      Line(x[5], y[0], x[5]+D*Pi, y[0]);
      exit;
    end;
    for i:=0 to 24 do
    begin
      x[4] := x[0]+D*Pi*i/48.0;
      y[4] := y[0]-(D-(0.5*D*(1+cos(7.5*i))))*tan(A);
      if i = 0 then
      begin
        x[1] := x[4];
        y[1] := y[4];
      end
      else if (i mod 2) = 1 then
      begin
        x[2] := x[4];
        y[2] := y[4];
      end
      else
      begin
        x[3] := x[4];
        y[3] := y[4];
        PrintArc(x[1], y[1], x[2], y[2], x[3], y[3], x[0]);
        x[1] := x[3];
        y[1] := y[3];
      end;
      if CheckBoxChecked(1) AND ((i mod 2)=0) AND (i < 24) then  // ⏕`
      begin
        if i=0 then
        begin
          LineType(3);  // 
        end
        else
        begin
          LineType(2);  // 
        end;
        Line(x[0]-D*Pi*i/48.0, y[5], x[0]-D*Pi*i/48.0, y[4]);
        Line(x[4], y[5], x[4], y[4]);
        LineType(0);  // 
      end;
    end;
  end;
End.
